package gs.smolban.model

import cats.Show
import gs.smolban.model.users.User

opaque type CreatedBy = User.Id

object CreatedBy:

  def apply(timestamp: User.Id): CreatedBy = timestamp

  given CanEqual[CreatedBy, CreatedBy] = CanEqual.derived

  given Show[CreatedBy] = _.toUserId().toUUID().withoutDashes()

  extension (createdAt: CreatedBy)
    /** Unwrap this value.
      *
      * @return
      *   The underlying `User.Id` value.
      */
    def toUserId(): User.Id = createdAt

end CreatedBy
