package gs.smolban.model

import cats.Show

/** Opaque type for a String that represents a unique `Tag` in Smolban. Tags are
  * just arbitrary non-empty strings which can be used to annotate [[Ticket]].
  *
  * Tags are defined _globally_ in Smolban.
  */
opaque type Tag = String

object Tag:

  def validate(candidate: String): Option[Tag] =
    if candidate.isEmpty() then None else Some(candidate)

  given CanEqual[Tag, Tag] = CanEqual.derived

  given Show[Tag] = t => t

end Tag
